::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:
sequence PARTIAL  pure:  Iterate over partial maches to dictionary codes.

 entry Map..Heap..string,             &Dictionary map number -> {code, ...}
       Key        string              :Key to partially match (all if empty).

  exit @Pair      Key..Heap..string   :Digits and associated code words

 local Prefix     string              :Shortest possible match

   use Phonecode/Short                :Shortest code word size
:
:...............................................................................


Prefix = left( Key, Short );      Shortest possible match

DO @P  from  Map( $, Prefix ):    DO over mapping keys,
   IF Has.Prefix( Key, P`Key ):      IF a partial or full match,
      Pair = @P
      YIELD;                            Export digits and associated code words.

   ELSE:                             ELSE no match,
UNDO IF P`Key > Key;              UNDO IF past matches.
-  .

return
